#include <eo>
#include <iostream> 

#include <tcl.h>
#include <tk.h>

using namespace std;


// todo: get rid of global stuff
bool bstop;
bool bexit;
bool bnext; 
bool bprint;

int stop( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- STOP ----------- \n");
  bstop = true;
  return 0;
} 

int cont( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- CONTINUE ----------- \n");
  bstop = false;
  return 0;
} 

int exit( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- EXIT ----------- \n");
  bstop = false; 
  bexit = true;
  return 0;
} 

int next( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- NEXT ----------- \n");
  bnext = true;
  return 0;
} 


int print( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- PRINT ----------- \n");
  bprint = true;
  return 0;
} 


template <class EOT> class myGui : public eoContinue<EOT> {

public:

  myGui() { Init(); bstop = true; bexit = false; bprint=false; iter=0; }; 
  

  void Init() {
    interp = Tcl_CreateInterp() ;
    Tcl_Init(interp);

    int ret;
    ret = Tk_Init(interp);
  
    if (ret != TCL_OK) {
      printf("Unable to initialize TK.\n");
      printf(interp->result);
    } 

    Tcl_CreateCommand( interp, "c_stop", stop, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_continue", cont, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_exit", exit, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_next", next, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_print", print, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );

    Tcl_EvalFile(interp,"gui/gui.txt");
  } 

  virtual bool operator()(const eoPop<EOT>& _pop) {
   
         
    cout << iter << ": "<<  _pop.best_element().fitness() << endl;
    iter++;

    bnext = false; 
    while (bstop && !bnext) { 

      Tcl_DoOneEvent(TCL_ALL_EVENTS);
 
      if (bprint) {
	eoPop<EOT> myPop  = _pop;
	myPop.sort();
	cout << myPop;
	bprint = false; 
      } 
    
    }; 
   
    Tcl_DoOneEvent(TCL_ALL_EVENTS | TCL_DONT_WAIT);

    
    return !bexit;
  }
  
private:
  Tcl_Interp *interp; 
  int iter; 
};
